"""Generate list of revision to skip for some benchmark
"""
import json
import os
import subprocess

from benchmarks.utils import read_yaml_file


def generate_skip_file(config):
    skip = {}
    for key, revsets in config["skip"].items():
        skiprev = set()
        for revset in revsets:
            for rev in subprocess.check_output(
                [
                    "hg",
                    "log",
                    "--cwd",
                    "mercurial",
                    "-r",
                    revset,
                    "-T",
                    "{node|short}\n",
                ]
            ).splitlines():
                skiprev.add(rev)
        skip[key] = list(skiprev)
    with open(os.path.join("repos", "skip.json"), "w") as f:
        json.dump(skip, f)


config = read_yaml_file("config.yaml")
skip = generate_skip_file(config)
