#!/bin/bash
#
# Script used to check that the machine is ready for running benchmarks. This
# script assumes that the asv command is in the current PATH

set -eox pipefail

# Ensure asv now machine characteristics
asv machine --yes

echo check that system is ready for benchmark
echo "(use ASV_SKIP_SYSTEM_CHECK=1 to skip it)"

if [ -z "${ASV_SKIP_SYSTEM_CHECK:-}" ]; then
    # Check that the machine is ready for benchmark
    python -m perf system show
fi

# Ensure all repository are here

if [ ! -d mercurial ]; then
    hg clone https://www.mercurial-scm.org/repo/hg mercurial
fi

mkdir -p repos/
mkdir -p repos/partial-references
make MAKE_VERBOSE=1 -f repos.make

./repo-scripts/rename-reference-directories repos

python create_skip_file.py
