SOURCE=https://static.octobus.net/asv/

all: |\
     repos/mercurial-2018-08-01-8ca6b045.benchrepo\
     repos/mercurial-2018-08-01-b793d407.benchrepo\
     repos/pypy-2018-08-01-ac75596e.benchrepo\
     repos/pypy-2018-08-01-08a61a72.benchrepo\
     repos/mozilla-central-2018-08-01-118d7d50.benchrepo\
     repos/mozilla-central-2018-08-01-453773b5.benchrepo\
     repos/netbeans-2018-08-01-6119fd1c.benchrepo\
     repos/netbeans-2018-08-01-85b533e8.benchrepo\
     repos/mozilla-try-2019-02-18-7047b153.benchrepo

.PHONY: all
.PRECIOUS:
.SECONDARY:

repos:
	mkdir repos

repos/partial-references: | repos
	mkdir repos/partial-references

repos/%.benchrepo:\
    repos/partial-references/%-partial-same/.hg/requires\
    repos/partial-references/%-partial-last-ten/.hg/requires\
    repos/partial-references/%-partial-last-hundred/.hg/requires\
    repos/partial-references/%-partial-last-thousand/.hg/requires\
    | repos
	(cd repos/; curl $(SOURCE)/$*-reference.tar | tar x --touch; hg -R $*-reference update tip)

repos/partial-references/%-partial-same/.hg/requires: | repos/partial-references
	(cd repos/partial-references/; curl $(SOURCE)/$*-partial-same.tar | tar x --touch)

repos/partial-references/%-partial-last-ten/.hg/requires: | repos/partial-references
	(cd repos/partial-references/; curl $(SOURCE)/$*-partial-last-ten.tar | tar x --touch)

repos/partial-references/%-partial-last-hundred/.hg/requires: | repos/partial-references
	(cd repos/partial-references/; curl $(SOURCE)/$*-partial-last-hundred.tar | tar x --touch)

repos/partial-references/%-partial-last-thousand/.hg/requires: | repos/partial-references
	(cd repos/partial-references/; curl $(SOURCE)/$*-partial-last-thousand.tar | tar x --touch)
