===================================================
test the "all in one" make-all that build reference
===================================================

Setup

(locally cache wheel)

  $ mkdir -p /tmp/.scm-perf-test/pip-cache
  $ export XDG_CACHE_HOME=/tmp/.scm-perf-test/pip-cache

  $ export PATH=$TESTDIR/../repo-scripts/:${PATH}
  $ mkdir some-dir
  $ hg init some-dir/my-source-repo
  $ hg -R some-dir/my-source-repo debugbuilddag  --new-file '.+5:brancha$.+11:branchb$.+30:branchc<brancha+2<branchb+2'

Define partial set

  $ cat << EOF >> p-config.yaml
  > partial-sets:
  >   same:
  >   missing-last-10:
  >     remove: "last(all(), 10)"
  > EOF

Wrong call
----------

  $ make-all
  usage: make-all HGVERSION SOURCE ID PARTIAL-SETS-FILE ARGS*
  all additional ARGS will be given to make-reference
  [64]

Good call
---------

  $ make-all 4.7 some-dir/my-source-repo testrepo p-config.yaml
  hg cloning repository from: some-dir/my-source-repo
  building a reference tarball
  result available at: testrepo-355c4044-reference.tar
  Cloning testrepo (testrepo-355c4044-reference stripped of last(all(), 10)) into ./testrepo-355c4044-partial-missing-last-10 (for exchange benchmarks)
  Cloning testrepo (testrepo-355c4044-reference stripped of None) into ./testrepo-355c4044-partial-same (for exchange benchmarks)

  $ ls -1 *.tar
  testrepo-355c4044-partial-missing-last-10.tar
  testrepo-355c4044-partial-same.tar
  testrepo-355c4044-reference.tar
  $ tar -axf testrepo-reference.tar testrepo.benchrepo -O
  tar: testrepo-reference.tar: Cannot open: No such file or directory
  tar: Error is not recoverable: exiting now
  [2]
