Test the scheduler

  $ export SCHEDULER_TEST_RUN_SCRIPT=$TESTDIR/scripts/scheduler-test-script-success
  $ export SCHEDULER_TEST_BISECT_SCRIPT=$TESTDIR/scripts/scheduler-test-bisect-script-success

  $ cat << EOF >> TASKS
  > RUN tip
  > EXIT
  > EOF

  $ python $TESTDIR/../scheduler.py TASKS
  Running test script tip
  ================================================================================
  Got task 'RUN' 'tip'
  RUNNING ['*/scheduler-test-script-success', 'tip'] (glob)
  
  
  
  Removed task 'RUN tip'
  ================================================================================
  ================================================================================
  Got task 'EXIT' None
  
  
  
  Removed task 'EXIT'
  ================================================================================

Scheduler should exit and the TASKS file should be now empty

  $ cat TASKS


Test log option of scheduler

  $ cat LOG
  cat: LOG: No such file or directory
  [1]
  $ cat << EOF >> TASKS
  > RUN tip
  > EXIT
  > EOF

  $ python $TESTDIR/../scheduler.py --log LOG TASKS
  Running test script tip
  ================================================================================
  Got task 'RUN' 'tip'
  RUNNING ['*/scheduler-test-script-success', 'tip'] (glob)
  
  
  
  Removed task 'RUN tip'
  ================================================================================
  ================================================================================
  Got task 'EXIT' None
  
  
  
  Removed task 'EXIT'
  ================================================================================

Scheduler should exit and the LOG file should have been populated

  $ cat LOG
  * Starting 'RUN' 'tip' (glob)
  * Ending 'RUN' 'tip' (glob)
  * Starting 'EXIT' None (glob)
  * Ending 'EXIT' None (glob)

Test scheduler bisect task

  $ cat << EOF >> TASKS
  > BISECT tip..tip~2 track_startup
  > EXIT
  > EOF

  $ python $TESTDIR/../scheduler.py TASKS
  Bisecting test script tip..tip~2 track_startup
  ================================================================================
  Got task 'BISECT' 'tip..tip~2 track_startup'
  Bisecting ['*/scripts/scheduler-test-bisect-script-success', 'tip..tip~2', 'track_startup'] (glob)
  
  
  
  Removed task 'BISECT tip..tip~2 track_startup'
  ================================================================================
  ================================================================================
  Got task 'EXIT' None
  
  
  
  Removed task 'EXIT'
  ================================================================================

Scheduler should exit and the TASKS file should be now empty

  $ cat TASKS

Test scheduler bisect task with full test name

  $ cat << EOF >> TASKS
  > BISECT tip..tip~2 basic_commands.TimeTestSuite.time_manifest_all('mercurial-2018-08-01')
  > EXIT
  > EOF

  $ python $TESTDIR/../scheduler.py TASKS
  Bisecting test script tip..tip~2 basic_commands.TimeTestSuite.time_manifest_all\('mercurial-2018-08-01'\)
  ================================================================================
  Got task 'BISECT' "tip..tip~2 basic_commands.TimeTestSuite.time_manifest_all('mercurial-2018-08-01')"
  Bisecting ['*/scripts/scheduler-test-bisect-script-success', 'tip..tip~2', "basic_commands.TimeTestSuite.time_manifest_all\\\('mercurial-2018-08-01'\\\)"] (glob)
  
  
  
  Removed task "BISECT tip..tip~2 basic_commands.TimeTestSuite.time_manifest_all('mercurial-2018-08-01')"
  ================================================================================
  ================================================================================
  Got task 'EXIT' None
  
  
  
  Removed task 'EXIT'
  ================================================================================

Scheduler should exit and the TASKS file should be now empty

  $ cat TASKS
