=============================
Make sure basic ASV run works
=============================

#require slow

initialize reference

  $ export HGRCPATH=
  $ export PATH=$TESTDIR/../repo-scripts/:${PATH}
  $ mkdir references
  $ hg init test-repo
  $ hg -R test-repo debugbuilddag --new-file .+2000
  $ cd references

Define partial set

  $ cat << EOF >> p-config.yaml
  > partial-sets:
  >   same:
  >   last-ten:
  >     remove: "last(all(), 10)"
  >   last-hundred:
  >     remove: "last(all(), 100)"
  >   last-thousand:
  >     remove: "last(all(), 1000)"
  > EOF

  $ make-reference ../test-repo smoke-test-A p-config.yaml
  hg cloning repository from: ../test-repo
  building a reference tarball
  result available at: smoke-test-A-11eb1fef-reference.tar

  $ make-reference ../test-repo smoke-test-B p-config.yaml
  hg cloning repository from: ../test-repo
  building a reference tarball
  result available at: smoke-test-B-4324509a-reference.tar

  $ make-partial-repos *.benchrepo
  Cloning smoke-test-A (smoke-test-A-11eb1fef-reference stripped of last(all(), 100)) into ./smoke-test-A-11eb1fef-partial-last-hundred (for exchange benchmarks)
  Cloning smoke-test-A (smoke-test-A-11eb1fef-reference stripped of last(all(), 10)) into ./smoke-test-A-11eb1fef-partial-last-ten (for exchange benchmarks)
  Cloning smoke-test-A (smoke-test-A-11eb1fef-reference stripped of last(all(), 1000)) into ./smoke-test-A-11eb1fef-partial-last-thousand (for exchange benchmarks)
  Cloning smoke-test-A (smoke-test-A-11eb1fef-reference stripped of None) into ./smoke-test-A-11eb1fef-partial-same (for exchange benchmarks)
  Cloning smoke-test-B (smoke-test-B-4324509a-reference stripped of last(all(), 100)) into ./smoke-test-B-4324509a-partial-last-hundred (for exchange benchmarks)
  Cloning smoke-test-B (smoke-test-B-4324509a-reference stripped of last(all(), 10)) into ./smoke-test-B-4324509a-partial-last-ten (for exchange benchmarks)
  Cloning smoke-test-B (smoke-test-B-4324509a-reference stripped of last(all(), 1000)) into ./smoke-test-B-4324509a-partial-last-thousand (for exchange benchmarks)
  Cloning smoke-test-B (smoke-test-B-4324509a-reference stripped of None) into ./smoke-test-B-4324509a-partial-same (for exchange benchmarks)
  $ cd ..

setup a copy of the asv repo

  $ rsync --exclude 'repos' --exclude 'mercurial' -ra $TESTDIR/.. test-asv
  $ cd test-asv
  $ cat << EOF > repos.make
  > SOURCE="$TESTTMP/references"
  > all: repos/smoke-test-A-11eb1fef.benchrepo repos/smoke-test-B-4324509a.benchrepo
  > 
  > repos/smoke-test-A-11eb1fef.benchrepo:
  > 	(cd repos; tar xf \$(SOURCE)/smoke-test-A-11eb1fef-reference.tar --warning=no-timestamp; hg -R smoke-test-A-11eb1fef-reference update --quiet tip)
  > 	(cd repos/partial-references/; tar xf \$(SOURCE)/smoke-test-A-11eb1fef-partial-last-hundred.tar --warning=no-timestamp )
  > 	(cd repos/partial-references/; tar xf \$(SOURCE)/smoke-test-A-11eb1fef-partial-last-ten.tar --warning=no-timestamp )
  > 	(cd repos/partial-references/; tar xf \$(SOURCE)/smoke-test-A-11eb1fef-partial-last-thousand.tar --warning=no-timestamp )
  > 	(cd repos/partial-references/; tar xf \$(SOURCE)/smoke-test-A-11eb1fef-partial-same.tar --warning=no-timestamp )
  > repos/smoke-test-B-4324509a.benchrepo:
  > 	(cd repos; tar xf \$(SOURCE)/smoke-test-B-4324509a-reference.tar --warning=no-timestamp; hg -R smoke-test-B-4324509a-reference update --quiet tip)
  > 	(cd repos/partial-references/; tar xf \$(SOURCE)/smoke-test-B-4324509a-partial-last-hundred.tar --warning=no-timestamp )
  > 	(cd repos/partial-references/; tar xf \$(SOURCE)/smoke-test-B-4324509a-partial-last-ten.tar --warning=no-timestamp )
  > 	(cd repos/partial-references/; tar xf \$(SOURCE)/smoke-test-B-4324509a-partial-last-thousand.tar --warning=no-timestamp )
  > 	(cd repos/partial-references/; tar xf \$(SOURCE)/smoke-test-B-4324509a-partial-same.tar --warning=no-timestamp )
  > EOF

setup appropriate virtual env

  $ mkdir -p /tmp/.scm-perf-test/pip-cache
  $ export XDG_CACHE_HOME=/tmp/.scm-perf-test/pip-cache
  $ virtualenv $TESTTMP/venv 1>/dev/null 2>&1
  $ export PATH=$TESTTMP/venv/bin:${PATH}
  $ PYTHONWARNINGS="ignore:DEPRECATION" pip --disable-pip-version-check install --requirement requirements.txt --quiet
  Switched to a new branch 'octobuspatches' (?)
  Branch '?octobuspatches'? set up to track remote branch '?octobuspatches'? from '?origin'?\. (re) (?)

run

  $ mkdir -p /tmp/.scm-perf-test/repo-pool
  $ cat << EOF >> test.hgrc
  > [ui]
  > quiet = yes
  > 
  > [extensions]
  > share=
  > 
  > [share]
  > pool = /tmp/.scm-perf-test/repo-pool
  > poolnaming = remote
  > EOF

  $ export HGRCPATH="${TESTTMP}"/test-asv/test.hgrc
  $ ASV_SKIP_SYSTEM_CHECK=1 ./launch.py -q fe3ca1e6 -b track_commit
  + asv machine --yes
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  * (glob)
  *: + echo check that system is ready for benchmark (glob)
  check that system is ready for benchmark
  + echo '(use ASV_SKIP_SYSTEM_CHECK=1 to skip it)'
  (use ASV_SKIP_SYSTEM_CHECK=1 to skip it)
  + '[' -z 1 ']'
  + hg clone https://www.mercurial-scm.org/repo/hg mercurial (?)
  requesting all changes (?)
  adding changesets (?)
  adding manifests (?)
  adding file changes (?)
  added * (glob) (?)
  updating to bookmark @* (glob) (?)
  new changesets * (glob) (?)
  * files updated, 0 files merged, 0 files removed, 0 files unresolved (glob) (?)
  + '[' '!' -d mercurial ']'
  + hg clone https://www.mercurial-scm.org/repo/hg mercurial
  + mkdir -p repos/
  + mkdir -p repos/partial-references
  + make MAKE_VERBOSE=1 -f repos.make
  (cd repos; tar xf "$TESTTMP/references"/smoke-test-A-11eb1fef-reference.tar --warning=no-timestamp; hg -R smoke-test-A-11eb1fef-reference update --quiet tip)
  (cd repos/partial-references/; tar xf "$TESTTMP/references"/smoke-test-A-11eb1fef-partial-last-hundred.tar --warning=no-timestamp )
  (cd repos/partial-references/; tar xf "$TESTTMP/references"/smoke-test-A-11eb1fef-partial-last-ten.tar --warning=no-timestamp )
  (cd repos/partial-references/; tar xf "$TESTTMP/references"/smoke-test-A-11eb1fef-partial-last-thousand.tar --warning=no-timestamp )
  (cd repos/partial-references/; tar xf "$TESTTMP/references"/smoke-test-A-11eb1fef-partial-same.tar --warning=no-timestamp )
  (cd repos; tar xf "$TESTTMP/references"/smoke-test-B-4324509a-reference.tar --warning=no-timestamp; hg -R smoke-test-B-4324509a-reference update --quiet tip)
  (cd repos/partial-references/; tar xf "$TESTTMP/references"/smoke-test-B-4324509a-partial-last-hundred.tar --warning=no-timestamp )
  (cd repos/partial-references/; tar xf "$TESTTMP/references"/smoke-test-B-4324509a-partial-last-ten.tar --warning=no-timestamp )
  (cd repos/partial-references/; tar xf "$TESTTMP/references"/smoke-test-B-4324509a-partial-last-thousand.tar --warning=no-timestamp )
  (cd repos/partial-references/; tar xf "$TESTTMP/references"/smoke-test-B-4324509a-partial-same.tar --warning=no-timestamp )
  + ./repo-scripts/rename-reference-directories repos
  Renaming repos/smoke-test-A-11eb1fef-reference into repos/smoke-test-A-11eb1fef
  Renaming repos/smoke-test-B-4324509a-reference into repos/smoke-test-B-4324509a
  + python create_skip_file.py
  - Fetching recent changes
  - Creating environments
  - Discovering benchmarks
  -- Uninstalling from virtualenv-py2.7-pyyaml
  -- Building fe3ca1e6 for virtualenv-py2.7-pyyaml
  -- Installing fe3ca1e6 into virtualenv-py2.7-pyyaml
  - Running 1 total benchmarks (1 commits * 1 environments * 1 benchmarks)
  [  0.00%] - For mercurial commit fe3ca1e6:
  [  0.00%] -- Benchmarking virtualenv-py2.7-pyyaml
  [100.00%] --- Setting up utils.py:*                                         ok (glob)
  [100.00%] --- basic_commands.TestSuite.track_commit                           ok
  [100.00%] --- ============== ========================= =============================== ======================= ===================== ========================== ============================ ========================== ======== =====================
                     repo       repo-format-compression   repo-format-compression-level   repo-format-dotencode   repo-format-fncache   repo-format-generaldelta   repo-format-plain-cl-delta   repo-format-sparserevlog    mode                        
                -------------- ------------------------- ------------------------------- ----------------------- --------------------- -------------------------- ---------------------------- -------------------------- -------- ---------------------
                 smoke-test-A             zlib                       default                       True                   True                    True                        True                        True             create   * (glob)
                 smoke-test-A             zlib                       default                       True                   True                    True                        True                        True             update   * (glob)
                 smoke-test-B             zlib                       default                       True                   True                    True                        True                        True             create   * (glob)
                 smoke-test-B             zlib                       default                       True                   True                    True                        True                        True             update   * (glob)
                ============== ========================= =============================== ======================= ===================== ========================== ============================ ========================== ======== =====================
  
  [ 11.11%] - Loading machine info
  [ 22.22%] - Getting params, commits, tags and branches
  [ 33.33%] - Loading results
  [ 44.44%] - Detecting steps
  [ 55.56%] - Generating graphs
  [ 66.67%] - Generating output for SummaryGrid
  [ 77.78%] - Generating output for SummaryList
  [ 88.89%] - Generating output for Regressions
  [100.00%] - Writing index
  + ['./lib/before-check.sh']
  + ['taskset', '-c', '2,3', 'asv', 'run', '--launch-method', 'spawn', '--skip-existing-successful', 'fe3ca1e6', '-b', 'track_commit']
  + ['asv', 'publish', '--no-pull']


check the repos directory afterwards

  $ ls repos/
  partial-references
  skip.json
  smoke-test-A-11eb1fef
  smoke-test-A-11eb1fef.benchrepo
  smoke-test-B-4324509a
  smoke-test-B-4324509a.benchrepo

  $ ls repos/partial-references/
  smoke-test-A-11eb1fef-partial-last-hundred
  smoke-test-A-11eb1fef-partial-last-ten
  smoke-test-A-11eb1fef-partial-last-thousand
  smoke-test-A-11eb1fef-partial-same
  smoke-test-B-4324509a-partial-last-hundred
  smoke-test-B-4324509a-partial-last-ten
  smoke-test-B-4324509a-partial-last-thousand
  smoke-test-B-4324509a-partial-same
